SystemOrganization addCategory: #KinematicTemplates!
SystemOrganization addCategory: #'KinematicTemplates-FFI'!

SimpleSwitchMorph subclass: #TemplatesOnOffSwitchMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!TemplatesOnOffSwitchMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 16:45'!
turnOff
	super turnOff.
	self label: 'Templates View OFF'
	! !

!TemplatesOnOffSwitchMorph methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 16:45'!
turnOn
	super turnOn.
	self label: 'Templates View ON'
	! !

!HaloMorph class methodsFor: '*KinematicTemplates' stamp: 'GermanLeiva 12/16/2012 15:38'!
kinematicHaloSpecifications
	"Answer an array that characterizes the locations, colors, icons, and selectors of the halo handles that may be used in the iconic halo scheme"

	"self installHaloTheme: #kinematicHaloSpecifications"

	^ #(
	"  	selector				horiz		vert			color info						icon key
		---------				------		-----------		-------------------------------		---------------"

	(addDismissHandle:	left				top				(gray lighter)			#haloDismissIcon)
	(addRotateHandle:		left				bottom			(gray lighter)			#haloRotIcon)
	(addDragHandle:		rightCenter		top				(gray lighter)			#haloDragIcon)
	(addDupHandle:		right			top				(gray lighter)			#haloDupIcon)	
	(addStrengthHandle:		right		center		(blue	veryMuchLighter)		#haloDebugIcon)
	(addGrowHandle:		right			bottom			(gray lighter)			#haloScaleIcon))
! !

!HaloMorph methodsFor: '*KinematicTemplates' stamp: 'GermanLeiva 12/16/2012 15:40'!
addStrengthHandle: haloSpec 
| slider |
slider:=   (self createSliderAt: (self
				positionIn: haloBox
				horizontalPlacement: haloSpec horizontalPlacement
				verticalPlacement: haloSpec verticalPlacement ) ).
slider top: slider top - (slider height / 2).
	self addMorph:slider.! !

!HaloMorph methodsFor: '*KinematicTemplates' stamp: 'GermanLeiva 12/16/2012 15:13'!
createSliderAt: aPoint
	^ ForceSlider new model: self target accessor: #strength; position: aPoint! !

RectangleMorph subclass: #KinematicCanvas
	instanceVariableNames: 'virtualCursor templates drawnPath lastDrawnPoint previousRealMousePosition handMorph lastVirtualCursorOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/15/2012 15:06'!
acceptDroppingMorph: aMorph event: evt
	super acceptDroppingMorph: aMorph event: evt.
	self addTemplate: aMorph.! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/15/2012 15:35'!
addTemplate: aTemplate
	^ templates add: aTemplate! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/16/2012 19:11'!
applyTemplates: realDelta forEvent: anEvent
	| selectedTemplates cursorPosition acumDelta acumPoint |
	selectedTemplates := templates select: [ :aTemplate | aTemplate containsPoint: lastDrawnPoint ].

	^selectedTemplates inject: realDelta into: [ :transformation :aTemplate | 
		aTemplate transformedDelta: transformation fromPoint: anEvent startPoint toPoint: anEvent endPoint withLastDrawnPoint: lastDrawnPoint].! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/15/2012 13:47'!
handleMouseMove: anEvent
	virtualCursor position: self activeHand position.
	super handleMouseMove: anEvent
! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'GermanLeiva 12/13/2012 20:41'!
handlesMouseDown: anEvent
	^true! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'GermanLeiva 12/13/2012 20:41'!
handlesMouseOver: evt
	^true! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 19:28'!
handlesMouseOverDragging: anEvent
	^true! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/16/2012 19:38'!
initialize
	| tpl1 tpl2 |
	super initialize.
	templates := OrderedCollection new.

	virtualCursor := KinematicCursor new.
	self addMorph: virtualCursor.
	
	HaloMorph installHaloTheme: #kinematicHaloSpecifications.! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/16/2012 13:32'!
mouseDown: event
	Transcript show: '>> mouseDown: ' ; cr.
	super mouseDown: event.
	Invokator hardwareDelta.
	lastDrawnPoint := virtualCursor position ifNil:[event cursorPoint].
	drawnPath  := LineMorph from: lastDrawnPoint to: lastDrawnPoint color: Color black width: 2.
	self addMorph: drawnPath.! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'GermanLeiva 12/13/2012 20:59'!
mouseEnter: event
	Transcript show: '>> mouseEnter: '; cr.
	super mouseEnter: event.
	self addMorph: virtualCursor.
	self currentHand showTemporaryCursor: Cursor blank.! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/16/2012 19:32'!
mouseEnterDragging: event
	self mouseEnter: event.! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/14/2012 04:13'!
mouseLeave: event
	Transcript show: '>> mouseLeave: '; cr.
	super mouseLeave: event.
	self currentHand showTemporaryCursor: nil.
	virtualCursor delete.
	drawnPath := nil.
	lastDrawnPoint := nil.
	lastVirtualCursorOffset := nil.! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/16/2012 18:57'!
mouseMove: event
	| realDelta delta |
	
	Transcript show: '>> mouseMove: '; cr.
	previousRealMousePosition ifNil: [ previousRealMousePosition := event startPoint ].	

	"realDelta := self activeHand position  -  previousRealMousePosition ."
	realDelta := Invokator hardwareDelta.

	
	delta := self applyTemplates: realDelta forEvent: event.
	
	drawnPath setVertices: (drawnPath vertices copyWith: lastDrawnPoint + delta).
		
	virtualCursor position: lastDrawnPoint + delta. 
		
	lastDrawnPoint := lastDrawnPoint + delta.

 	self activeHand showTemporaryCursor: Cursor blank.

"	self activeHand position: lastDrawnPoint  ."
	previousRealMousePosition := previousRealMousePosition + realDelta .
"	handMorph position: self activeHand position ."

! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/16/2012 18:57'!
mouseUp: event
	Transcript show: '>> mouseUp: '; cr.
	previousRealMousePosition := nil.

	drawnPath := nil.! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/15/2012 17:08'!
removeTemplate: aTemplate
	^ templates remove: aTemplate! !

!KinematicCanvas methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 14:14'!
showTemplates: aBoolean
	templates do: [ :aTemplate |
		aTemplate visible: aBoolean ]! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/15/2012 15:07'!
wantsDroppedMorph: aMorph event: evt
	^ aMorph isKindOf: KinematicTemplate! !

!KinematicCanvas methodsFor: 'accessing' stamp: 'carlaGriggio 12/16/2012 02:27'!
wantsHaloFromClick
	^ false! !

RectangleMorph subclass: #KinematicTemplate
	instanceVariableNames: 'background strength'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

KinematicTemplate subclass: #CompassTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!CompassTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:17'!
backgroundImageForm
	^Form fromFileNamed: 'compassTemplateBackground.png'! !

!CompassTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:15'!
radiusAdjustmentStrength
	^ self strength ! !

!CompassTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 23:48'!
thetaAdjustmentStrength
	^ 1! !

!CompassTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 01:43'!
transformedDelta: realDelta fromPoint: startPoint toPoint: endPoint withLastDrawnPoint: lastDrawnPoint
	| shiftPoint origR origTheta newR newTheta finalR finalTheta |
	shiftPoint := lastDrawnPoint - self center.
	
	origR := shiftPoint r.
	origTheta := shiftPoint theta.
	
	newR := (shiftPoint + realDelta) r.
	newTheta := (shiftPoint + realDelta) theta.
	
	finalR := (newR - origR) * self radiusAdjustmentStrength + origR.
  	finalTheta := (newTheta - origTheta) * self thetaAdjustmentStrength + origTheta.
	
	^Point 
		x: finalR * finalTheta cos - shiftPoint x
		y: finalR * finalTheta sin - shiftPoint y.! !

CompassTemplate subclass: #RadialTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!RadialTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:17'!
backgroundImageForm
	^Form fromFileNamed: 'radialTemplateBackground.png'! !

!RadialTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 23:49'!
radiusAdjustmentStrength
	^ 1! !

!RadialTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:15'!
thetaAdjustmentStrength
	^ self strength ! !

KinematicTemplate subclass: #GridTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!GridTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:18'!
backgroundImageForm
	^Form fromFileNamed: 'gridTemplateBackground.png'! !

!GridTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:16'!
transformedDelta: realDelta fromPoint: startPoint toPoint: endPoint withLastDrawnPoint: lastDrawnPoint
	^ (realDelta y abs > realDelta x abs
		ifTrue: [ (realDelta x * self strength ) @ (realDelta y * 1) ]
		ifFalse: [ (realDelta x * 1) @ (realDelta y * self strength ) ])! !

KinematicTemplate subclass: #HatchingTemplate
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!HatchingTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:18'!
backgroundImageForm
	^Form fromFileNamed: 'hatchingTemplateBackground.png'! !

!HatchingTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:16'!
transformedDelta: realDelta fromPoint: startPoint toPoint: endPoint withLastDrawnPoint: lastDrawnPoint
	^ (realDelta x * 1) @ (realDelta y * self strength )! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/15/2012 17:08'!
addFlexShell
	self owner removeTemplate: self.
	^ self owner addTemplate: super addFlexShell! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:53'!
bounds: aRect
	super bounds: aRect.
	"background center: self center."! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 01:34'!
dismissViaHalo
	owner ifNotNil:[ owner removeTemplate: self].
	super dismissViaHalo.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:15'!
initialize
	super initialize.
	self borderStyle: BorderStyle default.
	self color: Color transparent.
	background := self backgroundImageForm asMorph.
	self addMorph: background.
	background center: self center.
	self clipSubmorphs: true. 
	self strength: 0.2.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:53'!
layoutChanged
	super layoutChanged.
	background center: self center.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/15/2012 15:32'!
newTransformationMorph
	^ KinematicTransformation new! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 01:17'!
noteNewOwner: anOwner
	super noteNewOwner: anOwner.
	self layoutChanged.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/15/2012 14:59'!
printString
	^self className! !

!KinematicTemplate methodsFor: 'accessing' stamp: 'GermanLeiva 12/16/2012 15:14'!
strength
	^ strength! !

!KinematicTemplate methodsFor: 'accessing' stamp: 'GermanLeiva 12/16/2012 15:36'!
strength: anObject
	strength := anObject max: 0.001! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:27'!
updateBounds
	super updateBounds.
	background center: self center.! !

!KinematicTemplate methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/15/2012 14:40'!
wantsHaloFromClick
	^ true! !

TransformationMorph subclass: #KinematicTransformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!KinematicTransformation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:55'!
okayToResizeEasily
	^ true! !

!KinematicTransformation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 01:03'!
removeFlexShell
	self owner addTemplate: self.
	self owner addTemplate: self renderedMorph.
	^super removeFlexShell.! !

!KinematicTransformation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 17:07'!
strength
	^ self renderedMorph strength ! !

!KinematicTransformation methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 17:07'!
strength: aValue
	^ self renderedMorph strength: aValue! !

!KinematicTransformation methodsFor: 'accessing - properties' stamp: 'carlaGriggio 12/16/2012 18:56'!
transformedDelta: aDelta fromPoint: startPoint toPoint: endPoint withLastDrawnPoint: lastDrawnPoint
	| invertedStart invertedEnd invertedLastPoint delta transformedDelta inverseTransform adjustedDelta |

"	inverseTransform := transform inverseTransformation.
		
	invertedEnd := inverseTransform transform: endPoint.
	invertedStart := inverseTransform transform: startPoint.
	invertedLastPoint := inverseTransform transform: lastDrawnPoint.
	
	delta := invertedEnd - invertedStart.	"
	delta := (transform transform: endPoint ) - (transform transform: startPoint ).
	
	adjustedDelta := self renderedMorph transformedDelta: delta fromPoint: (transform transform: startPoint ) toPoint: (transform transform: endPoint )  withLastDrawnPoint:  (transform transform: lastDrawnPoint).

	transformedDelta :=  (transform inverseTransformation transform:  adjustedDelta + (transform transform: lastDrawnPoint) ) - lastDrawnPoint.
		
	Transcript
		show:  'delta: ' , delta asString;
		cr;
		show: 'inverted start ' , invertedStart asString;
		cr;
		show: 'start' , startPoint asString;
		cr;
		show: 'transformed delta ' , transformedDelta asString;
		cr.
	^ transformedDelta! !

!PasteUpMorph methodsFor: '*KinematicTemplates' stamp: 'carlaGriggio 12/15/2012 14:39'!
wantsHaloFromClick
	^false
! !

!MorphicEventHandler methodsFor: '*KinematicTemplates' stamp: 'carlaGriggio 12/16/2012 16:10'!
firstMouseSelector
	"Answer the selector corresponding to the first mouse-handling selector fielded.  Created in support of providing balloon-help for halo handles, triggered by the selector handled"
	self flag: #hack. "this has to be changed probably, nobody should depend on the first selector"
	subscriptions keysAndValuesDo: [ :eventKind :subscription | 
		(#(
			mouseDown
			mouseStillDown
			"mouseUp"
			mouseMove
			mouseEnter
			mouseLeave
			mouseEnterDragging
			mouseLeaveDragging
			doubleClick ) includes: eventKind) ifTrue: [ ^subscription anyOne selector ].
	].
	^nil! !

StandardWindow subclass: #KinematicWindow
	instanceVariableNames: 'virtualCursor templates drawnPath lastDrawnPoint canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

KinematicWindow class
	instanceVariableNames: 'uniqueInstance'!

!KinematicWindow class methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 19:36'!
openExample
	| w|
	w := self new.
	w openFullscreen  .

		
	! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:06'!
buildCompassIcon
	^(Form fromFileNamed: 'icon-compass-mini.png')! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:06'!
buildGridIcon
	^(Form fromFileNamed: 'icon-grid-mini.png')! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:07'!
buildHatchingIcon
	^(Form fromFileNamed: 'icon-hatching-mini.png')! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/15/2012 23:35'!
buildIcon

	| bitmap |
	bitmap :=  (Bitmap new: 256) copyFromByteArray:   #(137 80 78 71 13 10 26 10 0 0 0 13 73 72 68 82 0 0 0 16 0 0 0 16 8 6 0 0 0 31 243 255 97 0 0 24 30 105 67 67 80 73 67 67 32 80 114 111 102 105 108 101 0 0 88 9 173 89 121 60 85 221 215 223 231 220 17 247 154 231 89 230 121 158 51 207 243 60 166 114 141 215 172 107 86 36 73 166 66 134 20 82 72 164 104 52 37 68 82 146 41 81 138 20 133 82 105 64 166 188 135 167 158 231 249 125 126 239 251 223 123 62 159 115 206 247 174 253 221 107 175 189 214 62 251 156 181 46 0 156 183 72 225 225 193 48 61 0 33 161 145 20 123 19 125 126 87 55 119 126 220 43 64 3 24 0 61 160 5 28 36 239 136 112 61 91 91 75 240 127 30 203 163 0 218 110 124 42 189 173 235 255 164 253 239 13 12 62 190 17 222 0 64 182 72 179 151 79 132 119 8 130 111 1 128 106 242 14 167 68 2 128 217 214 39 20 19 25 190 141 115 16 204 76 65 12 68 112 229 54 246 255 11 55 109 99 175 191 112 223 14 199 209 222 0 225 76 1 128 39 144 72 20 127 0 136 11 136 156 63 218 219 31 209 67 75 0 0 203 24 234 19 16 138 116 227 71 176 182 55 153 228 3 0 167 39 194 145 10 9 9 219 198 89 8 22 243 250 151 30 255 127 97 18 201 235 111 157 36 146 255 223 248 175 185 32 61 145 129 13 3 34 194 131 73 113 59 63 254 63 47 33 193 81 136 191 118 14 94 228 74 136 8 114 176 64 238 172 136 223 98 189 73 70 14 8 102 71 240 73 178 175 153 229 111 121 85 120 164 190 253 111 121 107 64 164 153 35 130 153 17 206 8 57 202 212 233 55 158 139 10 114 210 67 48 55 34 223 8 10 179 216 230 35 126 130 217 67 189 172 109 16 204 136 96 33 239 8 3 196 247 219 99 193 42 241 100 71 151 223 28 75 31 95 67 35 4 35 171 8 118 165 132 217 255 225 147 35 162 29 254 200 227 227 201 6 214 127 248 129 36 243 237 120 211 34 252 12 18 5 65 59 246 192 69 190 193 38 219 227 238 66 228 87 194 35 109 183 237 220 30 171 63 52 216 250 247 92 224 25 63 138 241 54 103 91 190 230 27 177 51 223 109 219 200 145 100 71 83 68 142 216 140 162 143 164 56 110 115 144 57 162 184 253 2 140 205 16 140 216 134 146 35 83 76 255 200 117 195 131 119 214 52 210 23 229 72 137 178 223 246 131 16 130 253 124 67 157 182 125 184 45 207 240 33 25 110 251 22 241 9 170 4 24 3 18 160 0 95 224 5 66 193 60 224 7 150 192 0 24 254 190 242 35 242 80 68 230 13 194 64 48 114 82 248 233 254 180 96 222 99 134 48 111 49 207 48 83 152 23 127 100 72 207 223 60 16 0 124 16 252 151 174 127 245 71 228 14 32 30 124 66 180 250 130 136 63 163 161 57 209 218 104 77 180 37 114 213 69 78 5 180 26 90 253 79 91 255 66 227 194 31 252 219 86 127 164 175 244 111 221 250 191 173 143 70 52 110 254 225 237 15 72 166 252 193 191 251 120 253 221 227 191 109 50 6 51 136 7 252 255 48 228 106 229 230 229 54 254 244 255 103 198 88 35 172 33 214 20 107 140 21 71 165 161 110 162 122 80 247 80 143 80 173 168 70 192 143 106 71 53 161 250 80 119 183 241 111 187 254 140 66 66 36 219 94 217 246 112 4 176 64 188 232 11 162 118 126 133 254 25 239 63 188 20 245 55 227 183 6 90 9 90 101 96 143 244 10 5 65 72 91 192 223 35 56 239 88 29 240 95 90 162 16 134 23 50 98 32 194 181 248 59 30 191 237 66 139 32 222 85 70 235 163 181 16 63 35 62 70 179 162 57 129 52 90 9 241 184 30 90 7 137 129 50 34 253 39 138 255 57 27 105 224 183 227 237 232 157 185 4 129 247 200 60 66 34 125 99 35 145 181 4 12 194 194 227 40 1 254 228 72 126 61 100 183 244 149 226 55 11 245 150 145 226 87 144 147 87 0 219 123 239 54 7 128 239 246 59 123 42 196 58 240 143 140 20 12 128 154 2 0 212 250 255 200 194 144 181 89 87 128 60 14 103 254 145 137 32 207 25 135 58 0 55 236 189 163 40 209 127 233 67 111 223 48 128 26 208 33 79 5 7 224 5 130 64 12 241 136 2 80 1 154 64 23 24 1 115 96 3 28 129 27 216 135 172 97 50 8 65 44 142 1 135 192 17 144 10 50 65 14 40 0 103 65 25 168 0 213 224 42 184 1 26 65 43 184 7 30 128 199 96 16 60 3 47 193 20 120 7 62 130 69 176 12 214 33 8 194 65 68 136 9 226 128 248 32 97 72 18 82 128 212 32 109 200 8 178 132 236 33 55 200 19 242 135 66 161 40 232 16 116 20 202 132 78 65 103 161 11 80 13 116 29 106 134 238 65 143 160 33 232 5 244 6 154 135 190 65 107 48 10 38 192 204 48 15 44 2 203 194 106 176 30 108 1 59 194 123 97 127 248 0 28 15 167 192 39 225 34 184 28 190 2 55 192 247 224 199 240 51 120 10 254 8 47 161 0 138 6 197 138 18 64 73 163 212 80 6 40 27 148 59 202 15 69 65 37 162 50 80 133 168 114 84 29 170 5 89 139 79 81 83 168 5 212 42 26 139 102 66 243 163 165 145 72 154 162 157 208 222 232 3 232 68 116 22 250 44 186 26 221 128 190 143 126 138 126 131 94 68 255 194 16 49 220 24 73 140 6 198 12 227 138 241 199 196 96 82 49 133 152 42 204 109 76 55 242 60 191 195 44 99 177 88 86 172 40 86 21 89 237 110 216 64 236 65 108 22 182 20 91 143 237 192 14 97 167 177 75 56 28 142 3 39 137 211 194 217 224 72 184 72 92 42 238 12 238 10 174 29 55 140 123 135 251 137 167 193 243 225 21 240 198 120 119 124 40 62 25 95 136 191 140 111 195 15 227 103 241 235 84 244 84 194 84 26 84 54 84 62 84 113 84 217 84 149 84 45 84 3 84 239 168 214 169 25 168 69 169 181 168 29 169 3 169 143 80 23 81 215 81 119 83 191 162 254 78 67 67 179 139 70 157 198 142 38 128 38 137 166 136 230 26 205 67 154 55 52 171 4 70 130 4 193 128 224 65 136 34 156 36 92 34 116 16 94 16 190 19 137 68 17 162 46 209 157 24 73 60 73 172 33 118 17 39 137 63 105 153 104 101 104 205 104 125 104 15 211 22 211 54 208 14 211 126 166 163 162 19 166 211 163 219 71 23 79 87 72 119 147 110 128 110 129 158 138 94 132 222 128 158 68 159 72 95 76 223 76 63 70 191 196 192 196 32 207 96 195 16 194 144 197 112 153 225 17 195 28 35 142 81 132 209 136 209 135 49 133 177 130 177 139 113 154 9 197 36 200 100 192 228 205 116 148 169 146 169 155 233 29 51 150 89 148 217 140 57 144 57 147 249 42 115 63 243 34 11 35 139 18 139 51 75 44 75 49 203 93 150 41 86 20 171 8 171 25 107 48 107 54 235 13 214 81 214 53 54 30 54 61 54 95 182 116 182 58 182 97 182 21 118 46 118 93 118 95 246 12 246 122 246 103 236 107 28 252 28 70 28 65 28 185 28 141 28 19 156 104 78 9 78 59 206 24 206 115 156 221 156 11 92 204 92 154 92 222 92 25 92 55 184 198 185 97 110 9 110 123 238 131 220 21 220 125 220 75 60 188 60 38 60 225 60 103 120 186 120 22 120 89 121 117 121 3 121 243 121 219 120 231 249 152 248 180 249 2 248 242 249 218 249 62 240 179 240 235 241 7 243 23 241 223 231 95 20 224 22 48 21 136 18 184 32 208 47 176 190 75 116 151 211 174 228 93 245 187 38 4 169 5 213 4 253 4 243 5 59 5 23 133 248 132 172 132 14 9 213 10 141 11 83 9 171 9 147 133 79 11 247 8 175 136 136 138 184 136 28 23 105 20 153 19 101 23 53 19 141 23 173 21 125 37 70 20 211 17 59 32 86 46 54 34 142 21 87 19 15 18 47 21 31 148 128 37 148 37 200 18 197 18 3 146 176 164 138 100 128 100 169 228 144 20 70 74 93 42 84 170 92 106 76 154 32 173 39 29 45 93 43 253 70 134 85 198 82 38 89 166 81 230 179 172 144 172 187 108 174 108 143 236 47 57 101 185 96 185 74 185 151 242 140 242 230 242 201 242 45 242 223 20 36 20 188 21 138 21 70 20 137 138 198 138 135 21 155 20 191 42 73 42 249 42 157 83 122 174 204 164 108 165 124 92 185 83 121 83 69 85 133 162 82 167 50 175 42 164 234 169 90 162 58 166 198 172 102 171 150 165 246 80 29 163 174 175 126 88 189 85 125 85 67 69 35 82 227 134 198 23 77 105 205 32 205 203 154 115 187 69 119 251 238 174 220 61 173 181 75 139 164 117 65 107 74 155 95 219 83 251 188 246 148 142 128 14 73 167 92 231 173 174 160 174 143 110 149 238 172 158 184 94 160 222 21 189 207 250 114 250 20 253 219 250 43 6 26 6 9 6 29 134 40 67 19 195 12 195 126 35 70 35 39 163 179 70 147 198 187 140 253 141 107 141 23 77 148 77 14 154 116 152 98 76 45 76 115 77 199 204 120 204 188 205 106 204 22 205 85 205 19 204 239 91 16 44 28 44 206 90 188 181 148 176 164 88 182 88 193 86 230 86 121 86 175 172 133 173 67 173 27 109 128 141 153 77 158 205 132 173 168 237 1 219 59 118 88 59 91 187 98 187 247 246 242 246 135 236 123 28 152 28 246 59 92 118 88 118 212 119 204 118 124 233 36 230 20 229 212 233 76 231 236 225 92 227 188 226 98 232 114 202 101 202 85 214 53 193 245 177 27 167 91 128 91 147 59 206 221 217 189 202 125 105 143 209 158 130 61 239 60 148 61 82 61 70 247 138 238 141 221 251 104 31 231 190 224 125 119 247 211 237 39 237 191 233 137 241 116 241 188 236 185 65 178 33 149 147 150 188 204 188 74 188 22 189 13 188 79 123 127 244 209 245 201 247 153 247 213 242 61 229 59 235 167 229 119 202 111 206 95 203 63 207 127 158 172 67 46 36 47 4 24 4 156 13 248 26 104 26 88 22 184 18 100 19 116 41 104 43 216 37 184 62 4 31 226 25 210 28 202 24 26 20 122 63 140 55 44 54 108 40 92 50 60 53 124 234 128 198 129 130 3 139 20 11 74 85 4 20 177 55 162 41 146 25 249 200 237 139 18 139 58 22 245 38 90 59 186 56 250 103 140 115 204 205 88 134 216 208 216 190 56 137 184 244 184 217 120 227 248 139 7 209 7 189 15 118 30 18 56 116 228 208 155 4 189 132 11 137 80 162 87 98 231 97 193 195 41 135 223 37 153 36 85 31 161 62 18 116 228 73 178 92 242 169 228 31 71 93 142 182 164 240 164 36 165 76 31 51 57 86 155 74 155 74 73 29 59 174 121 188 44 13 157 22 144 214 159 174 152 126 38 253 87 134 79 70 111 166 92 102 97 230 70 150 119 86 239 9 249 19 69 39 182 78 250 157 236 207 86 201 62 151 131 205 9 205 25 205 213 201 173 62 197 112 42 254 212 116 158 85 94 67 62 127 126 70 254 143 130 253 5 143 10 149 10 203 78 83 159 142 58 61 85 100 89 212 116 70 232 76 206 153 141 179 228 179 207 138 245 139 235 75 184 75 210 75 86 74 125 74 135 207 233 158 171 43 227 41 203 44 91 59 31 112 254 249 5 147 11 13 229 34 229 133 21 216 138 232 138 247 149 206 149 61 23 213 46 214 84 113 86 101 86 109 94 10 189 52 85 109 95 125 191 70 181 166 230 50 247 229 236 90 184 54 170 118 254 138 199 149 193 171 134 87 155 234 164 235 46 212 179 214 103 94 3 215 162 174 125 184 238 121 125 244 134 197 141 206 155 106 55 235 110 9 223 42 185 205 116 59 163 1 106 136 107 88 108 36 55 78 53 185 53 13 53 155 55 119 182 104 182 220 190 35 115 231 82 171 64 107 241 93 150 187 217 109 212 109 41 109 91 237 241 237 75 29 225 29 11 247 252 239 77 119 238 239 124 217 229 218 53 114 223 238 126 127 183 69 247 195 7 198 15 186 122 244 122 218 31 106 61 108 125 164 241 168 185 87 173 183 241 177 202 227 134 62 229 190 219 79 148 159 220 238 87 233 111 24 80 29 104 26 84 31 108 25 218 61 212 54 172 51 124 239 169 225 211 7 35 102 35 143 159 89 63 27 26 117 26 125 62 230 49 54 245 220 231 249 220 139 224 23 95 199 163 199 215 95 38 189 194 188 202 152 160 159 40 156 228 158 44 127 45 254 186 126 74 101 234 238 27 195 55 125 111 29 222 190 156 246 158 254 56 19 49 179 241 46 229 61 241 125 225 44 223 108 205 156 194 92 235 188 241 252 224 135 61 31 222 125 12 255 184 190 144 250 137 225 83 201 103 177 207 183 190 232 126 233 91 116 93 124 247 149 242 117 235 91 214 119 142 239 151 126 40 253 232 92 178 93 154 92 14 89 94 95 201 248 201 241 179 122 85 109 181 103 205 101 109 118 61 102 3 183 81 180 41 190 217 242 203 226 215 171 173 144 173 173 112 18 133 180 243 45 128 66 174 176 159 31 0 223 46 33 121 145 27 0 76 131 200 55 5 237 95 185 209 14 3 249 220 133 16 14 130 157 33 25 232 35 124 31 117 20 237 128 209 197 138 226 56 241 236 84 124 212 90 52 214 132 32 98 14 109 51 221 2 131 52 163 47 83 5 243 52 171 4 91 28 123 59 39 29 151 11 119 37 207 119 190 221 252 41 2 79 4 25 132 236 133 79 136 60 22 3 226 138 18 126 146 167 165 122 165 87 100 197 228 236 228 147 20 106 21 159 41 195 42 242 170 123 213 50 212 27 52 222 236 38 106 169 105 123 234 164 235 94 215 123 101 128 55 84 49 242 54 206 49 105 50 157 52 135 44 132 44 77 172 2 173 179 109 110 217 62 183 251 233 192 234 168 232 100 227 28 226 114 194 181 206 237 177 251 155 61 139 30 43 123 215 247 3 79 106 18 135 151 180 183 158 143 189 239 126 63 95 127 18 217 33 96 119 32 127 16 20 52 21 220 30 114 62 244 104 24 57 220 246 128 26 133 63 2 31 241 37 114 52 170 45 186 58 38 47 54 49 46 56 222 237 160 217 33 173 4 213 68 149 195 234 73 122 71 44 146 93 142 250 166 68 30 59 150 154 127 188 50 237 102 122 71 70 95 230 104 214 235 19 179 39 63 101 127 203 89 202 93 62 181 148 183 148 191 86 136 62 205 82 36 117 198 228 172 119 241 225 146 162 210 186 115 237 101 143 207 143 92 24 47 159 170 152 175 252 81 133 186 196 82 45 81 163 127 217 163 54 230 74 254 213 27 117 67 245 95 175 51 220 80 188 233 112 43 226 118 78 67 77 99 75 211 189 230 174 150 142 59 119 90 111 223 173 111 171 105 175 232 40 189 87 208 153 209 117 232 126 96 183 195 3 149 30 246 158 213 135 83 143 6 122 31 60 238 234 187 247 164 181 191 126 160 104 48 98 200 96 152 56 252 244 105 241 136 223 51 229 81 204 232 216 88 245 243 232 23 186 227 216 241 30 100 125 41 191 154 157 200 157 212 156 156 126 125 98 74 115 234 227 155 178 183 246 211 168 233 250 25 167 153 213 119 249 239 165 222 183 207 218 207 206 204 29 155 151 157 159 249 80 253 49 116 65 113 97 233 83 253 103 239 47 12 95 110 47 218 46 190 255 122 232 27 219 183 7 223 179 127 132 46 145 150 253 144 117 52 179 214 189 41 179 181 181 19 127 65 232 26 28 136 82 64 205 161 175 99 146 176 174 56 45 188 52 149 40 181 40 205 46 130 28 81 131 214 142 206 155 62 145 161 140 177 141 105 158 133 158 85 141 141 196 158 198 113 139 115 146 155 134 71 145 119 15 95 18 255 5 129 246 93 47 5 151 132 105 68 248 68 149 197 204 196 61 37 226 36 243 164 174 75 247 201 204 201 161 229 5 20 118 43 186 43 69 42 103 170 84 170 54 171 61 81 127 171 241 99 55 86 139 75 91 94 199 74 55 88 47 91 255 154 193 160 225 39 99 188 9 143 169 130 153 145 185 147 133 183 101 168 85 172 117 162 205 81 219 99 118 169 246 105 14 25 142 89 78 25 206 41 46 113 174 100 55 71 119 195 61 58 30 198 123 221 247 197 236 47 240 188 70 234 244 234 245 238 246 185 237 91 226 119 208 223 133 44 23 64 8 88 8 28 12 106 9 174 9 41 14 205 14 75 14 167 28 240 160 232 70 240 69 172 71 62 139 186 26 157 26 227 21 107 20 39 23 47 116 144 231 16 71 2 75 34 253 97 236 225 229 164 183 71 122 147 175 31 45 72 137 57 182 55 213 252 184 97 154 101 58 41 227 72 230 197 172 7 39 38 79 126 206 94 202 89 201 93 58 245 61 111 49 255 83 193 66 225 231 211 63 207 208 159 85 47 14 45 169 42 237 63 55 93 54 127 254 221 133 215 229 47 42 134 42 31 94 108 171 106 189 212 91 253 233 178 64 237 222 43 37 87 95 212 51 95 179 190 158 134 236 94 171 183 101 26 124 26 139 155 134 91 48 119 148 90 247 223 61 214 86 213 222 218 209 118 239 114 103 78 87 194 253 152 238 164 7 217 61 165 15 43 30 157 235 61 249 56 170 207 225 137 116 63 186 127 124 224 198 96 230 80 224 176 221 83 163 17 163 103 118 163 94 99 81 207 83 94 28 31 79 120 233 247 202 96 130 115 98 97 178 249 245 241 41 215 55 210 111 241 111 223 79 119 205 148 190 59 240 94 119 150 48 59 50 87 49 127 248 67 192 71 159 5 242 167 144 207 225 95 194 23 195 191 82 190 69 127 143 251 17 179 20 176 108 178 66 183 114 243 167 209 207 199 171 238 171 159 214 6 55 8 155 227 59 241 151 4 247 33 11 232 57 236 139 194 162 178 209 146 232 1 76 60 86 22 59 143 187 136 39 83 201 82 173 82 247 210 148 17 98 136 246 180 10 116 180 116 203 244 47 24 58 24 107 152 242 152 19 88 252 89 237 217 180 216 197 57 88 56 54 56 231 184 134 185 219 120 234 120 43 248 138 249 11 5 242 119 101 11 166 10 69 11 147 68 140 68 249 69 127 138 245 137 151 73 68 72 154 74 9 72 195 210 243 50 99 178 15 229 90 228 47 43 20 41 38 41 121 42 171 171 96 85 6 84 11 212 92 213 57 212 95 104 148 106 250 236 86 208 194 106 77 106 55 232 100 235 146 245 12 245 69 12 232 13 129 225 119 163 89 227 81 147 59 166 133 102 190 230 194 230 83 22 69 150 54 86 56 171 46 235 163 54 102 182 236 182 31 236 218 236 243 28 200 142 154 78 68 167 73 231 171 46 135 92 205 221 88 220 94 187 87 239 9 67 222 255 171 123 239 238 75 218 111 224 137 247 28 34 149 120 5 121 239 246 33 248 140 251 94 242 59 224 175 230 191 65 110 15 72 10 212 13 2 65 29 193 71 66 12 66 209 161 221 97 199 194 245 194 127 30 168 165 184 33 239 236 154 72 155 200 31 81 69 209 187 163 39 99 146 98 121 98 239 198 121 198 179 198 143 31 172 61 116 52 193 53 81 44 113 249 112 87 82 222 17 255 100 195 163 18 41 236 199 104 82 65 234 143 227 211 105 79 210 235 51 178 50 73 89 74 39 112 39 198 79 94 203 206 200 9 202 53 57 197 120 234 65 222 158 188 133 252 248 2 189 66 253 211 105 103 240 103 51 138 103 74 57 206 41 148 169 159 87 191 160 92 46 91 33 86 41 112 145 163 138 225 18 117 53 85 13 29 178 146 180 174 120 94 61 94 119 181 254 233 181 141 27 98 55 221 111 157 186 61 212 200 220 228 214 92 210 50 214 138 185 43 222 102 210 238 213 113 248 222 185 206 182 174 215 247 183 30 8 244 24 60 244 127 148 213 123 253 241 104 223 102 191 248 192 158 193 211 67 147 79 21 70 78 60 251 60 230 240 188 121 92 224 101 193 132 236 107 218 55 49 51 153 115 113 159 172 191 45 175 218 109 199 255 175 26 217 246 59 1 171 2 64 30 146 103 58 159 64 206 121 0 114 27 1 16 185 3 0 27 53 0 182 68 0 28 213 1 124 188 14 192 38 117 0 10 58 246 247 251 3 2 104 128 71 114 78 86 192 7 196 129 18 146 105 90 2 119 36 223 142 5 233 72 70 121 5 180 129 97 36 59 222 128 24 33 113 72 23 201 15 35 160 19 72 62 216 13 77 195 16 44 0 235 195 62 240 113 36 203 27 134 215 80 130 40 43 84 60 170 26 53 134 198 163 53 208 33 232 10 244 11 12 35 198 2 201 200 186 176 16 86 23 155 132 237 196 97 112 230 184 28 220 115 188 0 62 24 223 76 133 163 114 161 170 166 90 163 182 162 190 64 189 66 99 77 83 77 64 19 188 8 93 68 97 98 58 241 51 173 35 109 43 146 233 228 210 3 250 3 244 51 12 110 12 3 140 198 140 119 153 212 152 26 152 53 152 187 88 236 89 166 89 163 216 176 108 133 236 34 236 77 28 214 28 115 156 105 92 242 92 211 220 101 60 94 188 146 188 63 249 30 240 23 8 248 236 82 18 196 10 190 20 186 41 156 45 18 44 106 33 38 41 78 20 95 148 120 38 121 71 234 156 116 162 140 135 172 186 28 179 220 162 252 19 133 203 138 233 74 100 101 115 21 25 85 22 213 45 181 79 234 147 26 195 154 189 187 187 181 238 107 247 232 244 235 142 235 205 233 47 27 2 35 44 178 207 225 77 241 102 84 230 4 11 102 75 1 43 37 107 107 155 80 219 124 187 86 251 119 142 68 39 37 103 55 151 4 215 243 110 247 221 103 61 104 246 202 237 115 222 127 200 179 146 212 239 245 211 71 200 215 193 239 152 127 43 121 45 208 32 232 76 240 106 168 119 216 240 1 99 74 107 164 82 84 125 140 116 236 245 248 221 7 7 19 194 14 115 39 141 38 231 167 88 30 91 62 158 159 46 149 209 157 229 123 146 37 251 117 238 147 188 137 130 173 34 254 179 234 37 150 231 246 159 143 43 63 95 57 126 73 186 230 252 21 185 186 169 235 23 110 237 107 164 105 174 107 221 219 46 217 201 215 109 252 176 188 143 48 32 54 180 60 146 59 38 246 98 232 213 185 215 167 223 14 191 247 156 95 253 196 248 229 202 55 240 67 110 89 125 101 107 53 99 173 105 125 100 227 206 102 197 175 240 45 213 157 253 3 218 169 57 48 2 46 32 130 212 26 116 128 21 240 64 106 11 137 32 23 84 130 102 48 128 212 13 54 33 86 72 22 50 135 252 144 138 64 57 82 5 120 11 163 97 81 216 18 166 192 103 225 46 248 11 138 27 101 129 58 132 170 71 205 32 181 47 123 116 38 186 27 3 97 180 48 7 49 119 48 27 88 29 236 81 236 35 28 61 206 13 119 17 247 13 175 135 207 195 191 167 210 164 202 163 90 160 54 70 98 190 65 227 74 115 11 201 132 41 132 17 162 58 241 60 45 13 109 44 237 44 157 27 93 63 189 49 125 7 131 54 67 59 163 1 99 47 147 3 211 4 146 153 174 177 100 179 74 176 62 102 59 192 206 202 222 192 97 199 241 158 51 142 139 200 85 201 173 203 61 195 147 203 107 206 71 203 55 193 127 83 224 228 174 0 65 125 33 118 161 143 194 119 69 114 68 253 196 244 197 133 37 24 37 241 82 24 105 188 12 173 44 163 28 131 60 94 126 85 97 78 113 76 169 87 249 158 202 61 213 94 181 151 234 223 52 105 119 203 105 217 105 7 232 68 234 82 244 200 250 174 6 38 134 234 70 74 198 106 38 38 166 251 205 18 205 47 88 244 88 46 90 115 217 24 217 6 33 239 180 124 135 211 142 5 78 249 206 231 93 218 93 191 186 43 239 73 242 120 178 143 119 127 164 231 128 151 160 183 159 79 129 239 109 191 126 255 25 242 122 32 107 144 98 176 99 72 116 232 217 176 142 240 15 20 182 8 227 200 232 168 75 209 227 177 244 113 86 241 217 7 159 39 136 36 38 28 158 62 226 127 148 62 165 55 53 50 13 155 126 60 19 157 149 118 146 43 187 43 55 57 207 181 192 224 180 230 25 205 98 205 82 245 50 241 11 232 242 7 149 209 85 92 151 238 214 120 213 178 92 153 168 235 190 54 112 99 233 182 124 227 161 230 199 173 116 109 134 29 148 206 170 251 243 61 250 143 110 244 201 247 151 12 78 12 255 24 249 58 58 251 124 122 124 238 213 143 215 208 27 234 105 230 119 66 179 166 243 133 11 170 95 50 190 87 173 4 175 246 175 167 108 116 109 254 248 181 186 19 127 24 121 250 25 144 106 147 52 208 6 118 72 85 44 1 20 130 107 160 15 124 128 168 144 218 144 21 68 129 138 160 14 232 3 204 10 27 194 145 112 21 60 142 98 64 153 161 82 80 29 168 77 164 50 19 143 110 65 111 96 244 48 25 152 49 172 56 246 8 118 2 167 141 43 199 227 241 97 248 17 42 117 170 82 106 24 169 133 60 163 49 164 185 67 80 39 220 35 218 18 223 211 38 211 9 208 117 208 123 208 47 51 228 48 74 51 62 97 10 101 38 50 87 179 232 179 188 98 141 99 227 101 235 103 63 201 225 197 169 207 37 193 205 204 189 206 51 193 219 196 119 138 63 68 192 114 151 156 32 187 16 86 104 85 248 171 200 23 209 239 98 155 18 180 146 66 82 186 210 158 50 73 178 165 114 77 242 79 21 190 43 113 42 155 169 36 171 118 169 19 52 60 52 175 105 225 144 111 213 54 189 93 250 121 134 172 70 117 38 238 102 12 230 67 150 103 173 195 108 157 236 21 28 198 157 220 157 251 92 77 221 158 238 241 243 248 185 239 168 39 68 10 247 122 230 163 234 91 226 79 69 62 18 72 29 84 17 98 21 6 194 27 41 97 145 188 81 93 49 81 113 62 7 63 39 86 38 197 29 25 77 222 72 129 143 225 83 233 143 43 166 69 164 143 100 58 101 205 159 76 203 145 201 125 145 151 86 160 89 248 181 168 230 236 190 18 234 210 75 101 170 231 239 150 235 84 116 92 52 172 234 173 182 173 25 169 117 188 50 88 103 92 223 124 93 236 198 233 91 248 219 9 13 27 77 233 45 34 119 6 239 38 183 171 116 204 119 150 220 183 121 128 238 185 243 40 226 177 100 223 76 255 185 65 215 97 230 167 195 207 178 199 204 159 111 141 95 121 101 51 49 247 58 106 106 243 109 242 12 234 93 242 44 60 119 244 3 250 227 225 133 207 159 141 191 196 45 150 126 61 241 45 234 187 225 247 149 31 151 151 172 151 94 46 147 151 151 87 162 87 230 127 122 252 28 88 53 88 173 93 35 174 133 175 13 175 43 175 23 173 127 221 48 219 40 223 88 223 116 220 188 250 11 245 203 245 215 149 45 104 203 105 235 242 118 252 35 252 20 145 122 37 114 64 4 125 164 252 56 185 181 245 93 4 0 220 41 0 54 115 183 182 214 203 183 182 54 43 144 100 227 21 0 29 193 127 253 239 178 77 198 34 181 250 146 215 219 168 87 226 209 133 237 251 191 143 255 1 173 175 191 173 105 26 203 40 0 0 0 9 112 72 89 115 0 0 11 19 0 0 11 19 1 0 154 156 24 0 0 2 55 105 84 88 116 88 77 76 58 99 111 109 46 97 100 111 98 101 46 120 109 112 0 0 0 0 0 60 120 58 120 109 112 109 101 116 97 32 120 109 108 110 115 58 120 61 34 97 100 111 98 101 58 110 115 58 109 101 116 97 47 34 32 120 58 120 109 112 116 107 61 34 88 77 80 32 67 111 114 101 32 53 46 49 46 50 34 62 10 32 32 32 60 114 100 102 58 82 68 70 32 120 109 108 110 115 58 114 100 102 61 34 104 116 116 112 58 47 47 119 119 119 46 119 51 46 111 114 103 47 49 57 57 57 47 48 50 47 50 50 45 114 100 102 45 115 121 110 116 97 120 45 110 115 35 34 62 10 32 32 32 32 32 32 60 114 100 102 58 68 101 115 99 114 105 112 116 105 111 110 32 114 100 102 58 97 98 111 117 116 61 34 34 10 32 32 32 32 32 32 32 32 32 32 32 32 120 109 108 110 115 58 116 105 102 102 61 34 104 116 116 112 58 47 47 110 115 46 97 100 111 98 101 46 99 111 109 47 116 105 102 102 47 49 46 48 47 34 62 10 32 32 32 32 32 32 32 32 32 60 116 105 102 102 58 88 82 101 115 111 108 117 116 105 111 110 62 55 50 60 47 116 105 102 102 58 88 82 101 115 111 108 117 116 105 111 110 62 10 32 32 32 32 32 32 32 32 32 60 116 105 102 102 58 89 82 101 115 111 108 117 116 105 111 110 62 55 50 60 47 116 105 102 102 58 89 82 101 115 111 108 117 116 105 111 110 62 10 32 32 32 32 32 32 32 32 32 60 116 105 102 102 58 67 111 109 112 114 101 115 115 105 111 110 62 49 60 47 116 105 102 102 58 67 111 109 112 114 101 115 115 105 111 110 62 10 32 32 32 32 32 32 32 32 32 60 116 105 102 102 58 79 114 105 101 110 116 97 116 105 111 110 62 49 60 47 116 105 102 102 58 79 114 105 101 110 116 97 116 105 111 110 62 10 32 32 32 32 32 32 32 32 32 60 116 105 102 102 58 80 104 111 116 111 109 101 116 114 105 99 73 110 116 101 114 112 114 101 116 97 116 105 111 110 62 50 60 47 116 105 102 102 58 80 104 111 116 111 109 101 116 114 105 99 73 110 116 101 114 112 114 101 116 97 116 105 111 110 62 10 32 32 32 32 32 32 60 47 114 100 102 58 68 101 115 99 114 105 112 116 105 111 110 62 10 32 32 32 60 47 114 100 102 58 82 68 70 62 10 60 47 120 58 120 109 112 109 101 116 97 62 10 186 203 126 33 0 0 2 136 73 68 65 84 56 17 109 83 61 79 98 65 20 61 15 65 222 227 35 20 80 216 105 99 98 3 33 33 81 64 66 52 49 161 178 179 146 216 82 187 133 127 192 208 187 5 36 90 216 193 47 128 80 208 64 40 77 84 12 137 186 184 46 46 81 32 46 154 8 44 223 97 118 238 213 183 21 83 192 157 59 119 206 189 231 204 121 138 144 11 115 22 165 21 69 153 115 34 83 116 227 235 200 168 87 136 217 76 38 21 12 135 67 204 100 108 177 88 48 30 143 49 153 76 160 170 42 12 6 3 250 253 62 255 211 94 249 66 48 232 0 138 44 160 142 197 98 17 233 116 154 227 151 151 23 156 158 158 98 97 97 129 247 169 84 10 165 82 137 99 186 71 83 242 4 212 229 225 225 1 163 209 8 133 66 1 183 183 183 8 6 131 184 186 186 98 48 191 223 15 155 205 134 92 46 135 149 149 21 172 174 174 98 121 121 153 129 9 69 116 187 93 113 116 116 68 204 132 44 22 107 107 107 34 20 10 9 159 207 199 113 32 16 16 155 155 65 177 190 190 206 53 241 120 92 72 170 116 85 48 192 116 58 21 157 78 135 129 146 201 164 56 60 60 20 131 193 64 200 113 197 193 193 129 104 52 26 162 39 155 124 147 249 68 34 33 228 164 82 178 25 3 48 5 226 104 183 219 89 14 135 195 193 49 9 229 114 185 96 181 90 177 180 180 196 188 173 146 134 211 233 196 226 226 34 215 210 0 12 32 187 33 147 201 128 68 43 151 203 120 126 126 198 217 217 25 106 191 106 184 190 190 198 201 247 19 104 170 134 203 203 75 92 92 92 176 30 145 72 4 38 147 233 19 128 212 215 52 141 59 155 205 102 238 64 162 105 22 141 139 108 86 27 84 77 133 201 104 226 58 154 78 95 60 1 37 118 119 119 57 103 183 217 113 255 227 30 209 104 148 95 230 245 207 43 98 177 24 159 61 254 124 132 219 237 198 206 206 14 239 137 2 251 128 140 67 6 154 140 39 248 232 124 160 215 235 177 153 222 222 222 208 255 219 7 253 147 169 200 72 239 239 239 252 254 116 153 38 87 72 74 58 56 63 63 71 165 82 65 179 217 68 171 213 194 246 246 54 164 250 184 185 185 225 152 132 35 254 181 90 13 199 199 199 60 33 229 152 130 209 104 196 214 214 22 54 54 54 144 205 102 241 244 244 132 253 253 125 6 148 207 139 189 189 61 126 141 118 187 13 50 149 244 200 167 137 36 17 6 32 36 226 70 235 238 238 14 3 73 199 235 245 178 152 249 124 30 225 112 152 207 232 89 61 30 15 59 145 18 68 131 141 68 166 208 141 81 255 93 23 213 106 149 152 9 201 87 72 64 33 173 206 123 202 215 235 117 142 245 31 214 128 225 191 16 245 79 88 22 252 255 104 244 110 243 206 254 1 182 150 130 9 182 25 3 169 0 0 0 0 73 69 78 68 174 66 96 130) asByteArray.
	^ Form extent: 16@16 depth: 32 bits: bitmap! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 00:06'!
buildRadialIcon
	^(Form fromFileNamed: 'icon-radial-mini.png')! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 01:14'!
createTemplate: aTemplateClass
	| newTemplate |
	newTemplate := aTemplateClass newBounds: Rectangle fromUser.
	canvas addMorph: newTemplate.
	canvas addTemplate: newTemplate.
	^newTemplate! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 16:49'!
initialize
	super initialize.
	Invokator resetInstance.
	self setLabel:'Kinematic Templates'.
	self width: 1000.
	self height: 700.
	canvas := KinematicCanvas new position: 0@25; width: 2000; height: 1000; color: Color white; borderStyle: BorderStyle default.
	self addMorph: canvas.
	self addMorph: self toolbar.
	
! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/16/2012 17:40'!
toolbar
	| switch panel button1 button2 button3 button4 |
	switch := TemplatesOnOffSwitchMorph  new
		turnOn;
		label: 'Templates View ON';
		position: 0 @ 2;
		color: Color veryVeryLightGray;
		onColor: Color veryVeryLightGray ;
		target: [:state | canvas showTemplates: state];
		actionSelector: #value:.
	self addMorph: switch.
	button1 := IconicButton new
		target: self;
		actionSelector: #createTemplate:;
		arguments: {HatchingTemplate};
		labelGraphic: self buildHatchingIcon;
		color: Color transparent;
		helpText: 'A really cool template';
		extent: 20 @ 20;
		borderWidth: 0.
	button2 := IconicButton new
		target: self;
		actionSelector: #createTemplate:;
		arguments: {GridTemplate};
		labelGraphic: self buildGridIcon;
		color: Color transparent;
		helpText: 'A really cool template';
		extent: 20 @ 20;
		borderWidth: 0.
	button3 := IconicButton new
		target: self;
		actionSelector: #createTemplate:;
		arguments: {CompassTemplate};
		labelGraphic: self buildCompassIcon;
		color: Color transparent;
		helpText: 'A really cool template';
		extent: 20 @ 20;
		borderWidth: 0.
	button4 := IconicButton new
		target: self;
		actionSelector: #createTemplate:;
		arguments: {RadialTemplate};
		labelGraphic: self buildRadialIcon;
		color: Color transparent;
		helpText: 'A really cool template';
		extent: 20 @ 20;
		borderWidth: 0.
	^ PanelMorph new
		position: 150 @ 2;
		changeTableLayout;
		cellInset: 10 @ 4;
		"layoutInset: 4 @ 4;"
		hResizing: #shrinkWrap;
		vResizing: #shrinkWrap;
		addMorph: button1;
		addMorph: button2;
		addMorph: button3;
		addMorph: button4;
		listDirection: #leftToRight;
		yourself	"		"! !

!KinematicWindow methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/15/2012 14:31'!
wantsHaloFromClick
	^ false! !

!Morph methodsFor: '*KinematicTemplates' stamp: 'carlaGriggio 12/16/2012 02:27'!
wantsHaloFromClick
	^ false! !

Slider subclass: #ForceSlider
	instanceVariableNames: 'label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!ForceSlider commentStamp: '<historical>' prior: 0!
A ForceSlider is a Sider that shows the force!

!ForceSlider methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:24'!
initialize
	super initialize.
	label := '0' asMorph.
	self addMorph: label.
	label center: self center + (30@0).! !

!ForceSlider methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:42'!
model: anObject accessor: selector
	super model: anObject accessor: selector.
	self value:( self modelValue)! !

!ForceSlider methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:31'!
modelValue
	^(self model perform: accessor)! !

!ForceSlider methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:42'!
setValue: newValue
	self value: newValue.
	accessor ifNotNil: [
		^ model perform: accessor asMutator with:  value
		].
	
	setValueSelector ifNotNil: [
		^model perform: setValueSelector with:  value
		].! !

!ForceSlider methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 14:35'!
sliderThickness
	^7! !

!ForceSlider methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 15:42'!
value: newValue
	super value: newValue.
	label contents: ((1 - newValue) round: 2) asString.! !

ExternalStructure subclass: #CGPoint
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates-FFI'!

!CGPoint class methodsFor: 'field definition' stamp: 'GermanLeiva 12/15/2012 00:43'!
fields
	^#(
		(x	'float')
		(y	'float')
	)! !

!CGPoint class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/15/2012 01:10'!
from: aPoint
	| newCGPoint |
	newCGPoint := self new.
	newCGPoint x: aPoint x.
	newCGPoint y: aPoint y + 45.
	^newCGPoint ! !

!CGPoint methodsFor: 'accessing' stamp: 'GermanLeiva 12/15/2012 00:44'!
x
	"This method was automatically generated"
	^handle floatAt: 1! !

!CGPoint methodsFor: 'accessing' stamp: 'GermanLeiva 12/15/2012 00:44'!
x: anObject
	"This method was automatically generated"
	handle floatAt: 1 put: anObject! !

!CGPoint methodsFor: 'accessing' stamp: 'GermanLeiva 12/15/2012 00:44'!
y
	"This method was automatically generated"
	^handle floatAt: 5! !

!CGPoint methodsFor: 'accessing' stamp: 'GermanLeiva 12/15/2012 00:44'!
y: anObject
	"This method was automatically generated"
	handle floatAt: 5 put: anObject! !

Object subclass: #Invokator
	instanceVariableNames: 'pointer1 deltaX pointer2 deltaY'
	classVariableNames: 'Instance'
	poolDictionaries: ''
	category: 'KinematicTemplates-FFI'!

!Invokator commentStamp: '<historical>' prior: 0!
An Invokator is something related with FFI.

For installing FFI

Gofer it
        squeaksource: 'MetacelloRepository' ;
        package: 'ConfigurationOfFFI' ;
        load.
(ConfigurationOfFFI project version: '1.5') load.
!

!Invokator class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 12:49'!
apiCGGetLastMouseDeltaX: deltaX deltaY: deltaY
    "void CGGetLastMouseDelta (int32_t *deltaX,int32_t *deltaY);"
    < apicall: void 'CGGetLastMouseDelta' (short* short* )  module: 'CoreGraphics.framework'>   
    ^ self externalCallFailed.    
! !

!Invokator class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/15/2012 01:00'!
apiCGWarpMouseCursorPosition: aCGPoint
    "CGError CGWarpMouseCursorPosition(CGPoint newCursorPosition);"
    < apicall: void 'CGWarpMouseCursorPosition' ( CGPoint )  module: 'CoreGraphics.framework'>   
    ^ self externalCallFailed.    
! !

!Invokator class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 13:28'!
hardwareDelta
	^self instance hardwareDelta! !

!Invokator class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 13:28'!
instance
	Instance ifNil: [ Instance := self new ].
	^Instance! !

!Invokator class methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 13:57'!
resetInstance
	Instance := nil.! !

!Invokator methodsFor: 'as yet unclassified' stamp: 'GermanLeiva 12/16/2012 13:27'!
hardwareDelta
	pointer1 ifNil: [pointer1 := ExternalAddress allocate: ExternalType short byteSize ].
	deltaX ifNil: [deltaX := ExternalData fromHandle: pointer1 type: ExternalType short asPointerType ].
	pointer2 ifNil: [pointer2 := ExternalAddress allocate: ExternalType short byteSize ].
	deltaY ifNil: [deltaY := ExternalData fromHandle: pointer2 type: ExternalType short asPointerType].

	Invokator apiCGGetLastMouseDeltaX: deltaX deltaY: deltaY.

	^(pointer1 signedShortAt: 1) @ (pointer2 signedShortAt: 1)! !

CircleMorph subclass: #KinematicCursor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KinematicTemplates'!

!KinematicCursor methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 23:44'!
initialize
	super initialize.
	self color: Color black.
	self width: 7; height: 7.! !

!KinematicCursor methodsFor: 'as yet unclassified' stamp: 'carlaGriggio 12/14/2012 23:43'!
wantsHaloFromClick
	^ false! !
